# -*- coding: utf-8 -*-
# ========================================================================
#  2022/5/25 22:30
#                 _____   _   _   _____   __   _   _____  
#                /  ___| | | | | | ____| |  \ | | /  ___| 
#                | |     | |_| | | |__   |   \| | | |     
#                | |     |  _  | |  __|  | |\   | | |  _  
#                | |___  | | | | | |___  | | \  | | |_| | 
#                \_____| |_| |_| |_____| |_|  \_| \_____/ 
# ------------------------------------------------------------------------
# 
# 
# 
# ========================================================================

import sys
sys.path.append('../')
import configparser
from predict_structure_by_binding_energy import FindMaxBindingEnergyMaterial


# comp = 'Si4 V4'
# comp = 'Mg4 Br8'
# comp = 'Mg4 Se4'
# comp = 'Na4 Br4'
# comp = 'Cu4 Br4'
# comp = 'K4 Br4'
# comp = 'V4 O10'
# comp = 'V4 F8'
# comp = 'S4 O8'

# comp = 'Mg4 Se4'
# comp = 'Zn2 Mg6'
# comp = 'Zn2 K6'
# comp = 'V2 F4'
comp = 'Zr4 C4'

config = configparser.ConfigParser()
config.add_section('BASE')
# config.set('BASE', 'compound', comp)
# config.set('BASE', 'output_path', './results/Zr_C/' + comp.replace(' ', ''))
config.set('BASE', 'atom_element', '[1-40] [1-40]')
config.set('BASE', 'atom_count', '[1-5] [1-5]')
config.set('BASE', 'use_children_cell', 'False')
config.set('BASE', 'min_atomic_dist_limit', '-0.6')
config.set('BASE', 'volume_limit', '[0, 500]')
config.set('BASE', 'max_vacuum_limit', '5.0')
config.set('BASE', 'output_path', './results/Zr_C/Zr_C_5_2')

config.add_section('CALCULATOR')
config.set('CALCULATOR', 'calculator', 'm3gnet')
config.set('CALCULATOR', 'calculator_path', r'F:\d3ream\calculators\m3gnet\origin_model\EFS2021')
config.set('CALCULATOR', 'use_calculator_relax', 'True')
config.set('CALCULATOR', 'use_keep_symmetry', 'False')
config.set('CALCULATOR', 'symprec', '0.001')
config.set('CALCULATOR', 'use_gpu', 'True')

config.add_section('OPTIMIZER')
config.set('OPTIMIZER', 'algorithm', "tpe2")
config.set('OPTIMIZER', 'n_init', '200')
config.set('OPTIMIZER', 'max_step', '5000')
config.set('OPTIMIZER', 'rand_seed', '100')
config.set('OPTIMIZER', 'use_resume', 'False')
config.set('OPTIMIZER', 'n_mpi', '1')
config.set('OPTIMIZER', 'storage', '')

config.add_section('LATTICE')
config.set('LATTICE', 'space_group', '[%d-%d]' % (1, 230))
# config.set('LATTICE', 'use_flexible_site', 'False')
config.set('LATTICE', 'wyck_pos_gen', '1')
config.set('LATTICE', 'max_wyck_pos_count', '200000')
config.set('LATTICE', 'lattice_a', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_b', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_c', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_alpha', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_beta', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_gamma', '[%f-%f]' % (20.0, 160.0))

FindMaxBindingEnergyMaterial(None, config)
# with joblib.parallel_backend('loky'):
#     joblib.Parallel(verbose=100)(
#         joblib.delayed(target_class)(None, config, study_name)
#         for _ in range(n_mpi)
#     )
