# -*- coding: utf-8 -*-
# ========================================================================
#  2022/5/25 22:30
#                 _____   _   _   _____   __   _   _____  
#                /  ___| | | | | | ____| |  \ | | /  ___| 
#                | |     | |_| | | |__   |   \| | | |     
#                | |     |  _  | |  __|  | |\   | | |  _  
#                | |___  | | | | | |___  | | \  | | |_| | 
#                \_____| |_| |_| |_____| |_|  \_| \_____/ 
# ------------------------------------------------------------------------
# 
# 
# 
# ========================================================================

import sys
sys.path.append('../')
import configparser
from predict_structure_new_way_Eb import FindMaxBindingEnergyMaterial


config = configparser.ConfigParser()
config.add_section('BASE')
config.set('BASE', 'atom_element', '[1,3-9,11-17,19-22,29-35,37-40,47-53,55-56,81-83] [1,3-9,11-17,19-22,29-35,37-40,47-53,55-56,81-83]')
config.set('BASE', 'atom_count', '[1-5] [1-5]')
config.set('BASE', 'use_children_cell', 'True')
config.set('BASE', 'min_atomic_dist_limit', '-0.6')
config.set('BASE', 'volume_limit', '[0, 0]')
config.set('BASE', 'max_vacuum_limit', '7.0')
config.set('BASE', 'output_path', './results/new_sample_way_2/')

config.add_section('CALCULATOR')
config.set('CALCULATOR', 'calculator', 'm3gnet')
config.set('CALCULATOR', 'calculator_path', r'F:\d3ream\calculators\m3gnet\origin_model\EFS2021')
config.set('CALCULATOR', 'use_calculator_relax', 'True')
config.set('CALCULATOR', 'use_keep_symmetry', 'False')
config.set('CALCULATOR', 'symprec', '0.001')
config.set('CALCULATOR', 'use_gpu', 'False')

config.add_section('OPTIMIZER')
config.set('OPTIMIZER', 'algorithm', "rand")
config.set('OPTIMIZER', 'n_init', '10')
config.set('OPTIMIZER', 'max_step', '1000')
config.set('OPTIMIZER', 'rand_seed', '-1')
config.set('OPTIMIZER', 'use_resume', 'False')
config.set('OPTIMIZER', 'n_mpi', '1')
config.set('OPTIMIZER', 'storage', '')

config.add_section('LATTICE')
config.set('LATTICE', 'space_group', '[%d-%d]' % (1, 230))
# config.set('LATTICE', 'use_flexible_site', 'False')
config.set('LATTICE', 'wyck_pos_gen', '1')
config.set('LATTICE', 'max_wyck_pos_count', '200000')
config.set('LATTICE', 'lattice_a', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_b', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_c', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_alpha', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_beta', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_gamma', '[%f-%f]' % (20.0, 160.0))

FindMaxBindingEnergyMaterial(None, config)
# with joblib.parallel_backend('loky'):
#     joblib.Parallel(verbose=100)(
#         joblib.delayed(target_class)(None, config, study_name)
#         for _ in range(n_mpi)
#     )
