# -*- coding: utf-8 -*-
# ========================================================================
#  2022/5/25 22:30
#                 _____   _   _   _____   __   _   _____  
#                /  ___| | | | | | ____| |  \ | | /  ___| 
#                | |     | |_| | | |__   |   \| | | |     
#                | |     |  _  | |  __|  | |\   | | |  _  
#                | |___  | | | | | |___  | | \  | | |_| | 
#                \_____| |_| |_| |_____| |_|  \_| \_____/ 
# ------------------------------------------------------------------------
# 
# 
# 
# ========================================================================

import sys

sys.path.append('../')

import configparser

import joblib
# from predict_structure_MOO import FindPhotovoltaicMaterial
from predict_structure_Fn import FindPhotovoltaicMaterial

config = configparser.ConfigParser()

config.add_section('BASE')
config.set('BASE', 'atom_element', '[5-7,13-15,31-33,49-51] [5-7,13-15,31-33,49-51]')
config.set('BASE', 'atom_count', '[1-2] [1-2]')
config.set('BASE', 'output_path', './results/photovoltaic_pred7')
config.set('BASE', 'use_children_cell', 'True')
config.set('BASE', 'min_atomic_dist_limit', '-0.4')
config.set('BASE', 'volume_limit', '[0, 0]')
config.set('BASE', 'max_vacuum_limit', '7.0')

config.add_section('CALCULATOR')
config.set('CALCULATOR', 'calculator', 'm3gnet')
config.set('CALCULATOR', 'calculator_path', r'F:\d3ream\calculators\m3gnet\origin_model\EFS2021')
config.set('CALCULATOR', 'use_calculator_relax', 'True')
config.set('CALCULATOR', 'use_keep_symmetry', 'True')
config.set('CALCULATOR', 'symprec', '0.001')
config.set('CALCULATOR', 'use_gpu', 'False')

config.add_section('OPTIMIZER')
config.set('OPTIMIZER', 'algorithm', "tpe2")
config.set('OPTIMIZER', 'n_init', '60')
config.set('OPTIMIZER', 'max_step', '6000')
config.set('OPTIMIZER', 'rand_seed', '100')
config.set('OPTIMIZER', 'use_resume', 'False')
config.set('OPTIMIZER', 'n_mpi', '1')
config.set('OPTIMIZER', 'storage', 'mysql+pymysql://root:950912@localhost/d3ream')

config.add_section('LATTICE')
config.set('LATTICE', 'space_group', '[%d-%d]' % (1, 230))
config.set('LATTICE', 'use_flexible_site', 'True')
config.set('LATTICE', 'lattice_a', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_b', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_c', '[%f-%f]' % (2.0, 30.0))
config.set('LATTICE', 'lattice_alpha', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_beta', '[%f-%f]' % (20.0, 160.0))
config.set('LATTICE', 'lattice_gamma', '[%f-%f]' % (20.0, 160.0))

FindPhotovoltaicMaterial(None, config, study_name='photovoltaic_7', is_mpi_run=True)

# n_mpi = 2
# with joblib.parallel_backend('loky', n_jobs=2):
#     joblib.Parallel(verbose=100)(
#         joblib.delayed(FindPhotovoltaicMaterial)(None, config, study_name='photovoltaic_4', is_mpi_run=True)
#         for _ in range(n_mpi)
#     )z
